/*
 * core.min.js  version 7.2
 *
 * Copyright (c) 2015-2023 Emmanuel PUYBARET / eTeks <info@eteks.com>
 * 
 * Copyright (c) 1997, 2013, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied OpenJDK 8 source code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 */
function IllegalArgumentException(a){this.message=a}function ParseException(b,a){this.message=b;this.errorOffset=a}function NullPointerException(a){this.message=a}function IllegalStateException(a){this.message=a}function UnsupportedOperationException(a){this.message=a}function InternalError(a){this.message=a}function NoSuchElementException(a){this.message=a}var System={};System.arraycopy=function(e,d,g,f,c){if(e!==g||f>=d+c){while(--c>=0){g[f++]=e[d++]}}else{var b=e.slice(d,d+c);for(var a=0;a<c;a++){g[f++]=b[a]}}};function EventObject(a){this.source=a}EventObject.prototype.getSource=function(){return this.source};function PropertyChangeEvent(c,a,b,d){EventObject.call(this,c);this.propertyName=a;this.newValue=d;this.oldValue=b}PropertyChangeEvent.prototype=Object.create(EventObject.prototype);PropertyChangeEvent.prototype.constructor=PropertyChangeEvent;PropertyChangeEvent.prototype.getPropertyName=function(){return this.propertyName};PropertyChangeEvent.prototype.getNewValue=function(){return this.newValue};PropertyChangeEvent.prototype.getOldValue=function(){return this.oldValue};function PropertyChangeSupport(a){this.source=a;this.listeners=[]}PropertyChangeSupport.prototype.addPropertyChangeListener=function(a,b){if(b===undefined){b=a;a=null}if(b){if(a){this.listeners.push({listener:b,propertyName:a})}else{this.listeners.push({listener:b})}}};PropertyChangeSupport.prototype.removePropertyChangeListener=function(a,c){if(c===undefined){c=a;a=undefined}if(c){for(var b=this.listeners.length-1;b>=0;b--){if(this.listeners[b].propertyName==a&&this.listeners[b].listener===c){this.listeners.splice(b,1)}}}};PropertyChangeSupport.prototype.getPropertyChangeListeners=function(a){if(a===undefined){return this.listeners.slice(0)}else{var c=[];for(var b=this.listeners.length-1;b>=0;b--){if(this.listeners[b].propertyName==a){c.push(this.listeners[b])}}return c}};PropertyChangeSupport.prototype.firePropertyChange=function(a,b,e){if(b!=e){var d=new PropertyChangeEvent(this.source,a,b,e);for(var c=0;c<this.listeners.length;c++){if(!("propertyName" in this.listeners[c])||this.listeners[c].propertyName==a){if(typeof(this.listeners[c].listener)==="function"){this.listeners[c].listener(d)}else{this.listeners[c].listener.propertyChange(d)}}}}};function StringWriter(){this.buffer=""}StringWriter.prototype.write=function(a){return this.buffer+=a};StringWriter.prototype.toString=function(a){return this.buffer};function Format(){}Format.prototype.format=function(a){return""+a};Format.prototype.parseObject=function(b,a){var c=a===undefined;if(a===undefined){a=new ParsePosition(0)}var d=this.parse(b,a);if(c&&a.getIndex()!==b.length){throw new ParseException(b,a.getIndex())}return d};Format.prototype.parse=function(b,a){var c=a===undefined?b:b.substring(a.getIndex());var d=Date.parse(c);if(isNaN(d)){var d=parseInt(c);if(isNaN(d)){var d=parseFloat(c);if(isNaN(d)){if(a===undefined){throw new ParseException(c,0)}else{return null}}}}if(a!==undefined){a.setIndex(b.length)}return d};Format.prototype.clone=function(){var b=Object.create(this);for(var a in this){if(this.hasOwnProperty(a)){b[a]=this[a]}}return b};function ParsePosition(a){this.index=a;this.errorIndex=-1}ParsePosition.prototype.getIndex=function(){return this.index};ParsePosition.prototype.setIndex=function(a){this.index=a};ParsePosition.prototype.getErrorIndex=function(){return this.errorIndex};ParsePosition.prototype.setErrorIndex=function(a){this.errorIndex=a};function NumberFormat(){Format.call(this);this.groupingUsed=false;this.minimumFractionDigits=0;this.maximumFractionDigits=2}NumberFormat.prototype=Object.create(Format.prototype);NumberFormat.prototype.constructor=NumberFormat;NumberFormat.prototype.setGroupingUsed=function(a){this.groupingUsed=a};NumberFormat.prototype.isGroupingUsed=function(){return this.groupingUsed};NumberFormat.prototype.setPositivePrefix=function(a){this.positivePrefix=a};NumberFormat.prototype.getPositivePrefix=function(){return this.positivePrefix};NumberFormat.prototype.setNegativePrefix=function(a){this.negativePrefix=a};NumberFormat.prototype.getNegativePrefix=function(){return this.negativePrefix};NumberFormat.prototype.setMinimumFractionDigits=function(a){this.minimumFractionDigits=a};NumberFormat.prototype.getMinimumFractionDigits=function(){return this.minimumFractionDigits};NumberFormat.prototype.setMaximumFractionDigits=function(a){this.maximumFractionDigits=a};NumberFormat.prototype.getMaximumFractionDigits=function(){return this.maximumFractionDigits};NumberFormat.getNumberInstance=function(){return new DecimalFormat("#.##")};NumberFormat.getIntegerInstance=function(){return new IntegerFormat()};NumberFormat.getCurrencyInstance=function(){return new CurrencyFormat()};function DecimalFormat(c){NumberFormat.call(this);this.checkLocaleChange();var b=0;var d=2;if(c!==undefined&&c.trim()!=""){var f=c.split(";");var e=f[0].match(/[.]([0]+)([#]*)/);if(e==null){b=0;e=f[0].match(/[.]([#]*)/);if(e==null){d=0}else{if(e.length>1){d=e[1].length}}}else{if(e.length>1){b=e[1].length;if(e.length>2&&e[2].length>0){d=b+e[2].length}}}if(f.length>1){var a=f[0].trim();this.positivePrefix=a.substring(0,Math.min(a.indexOf("#"),a.indexOf("0")));a=f[1].trim();this.negativePrefix=a.substring(0,Math.min(a.indexOf("#"),a.indexOf("0")))}else{var a=f[0].trim();this.positivePrefix=this.negativePrefix=a.substring(0,Math.min(a.indexOf("#"),a.indexOf("0")))}}if(d<b){d=b}this.setMinimumFractionDigits(b);this.setMaximumFractionDigits(d)}DecimalFormat.prototype=Object.create(NumberFormat.prototype);DecimalFormat.prototype.constructor=DecimalFormat;DecimalFormat.prototype.format=function(a){if(a==null){return""}this.checkLocaleChange();var b=toLocaleStringUniversal(a,this.groupingSeparator,this.isGroupingUsed(),this.decimalSeparator,{minimumFractionDigits:this.getMinimumFractionDigits(),maximumFractionDigits:this.getMaximumFractionDigits(),positivePrefix:this.positivePrefix,negativePrefix:this.negativePrefix});return b};DecimalFormat.prototype.parse=function(c,b){this.checkLocaleChange();var a=parseLocalizedNumber(c,b,{decimalSeparator:this.decimalSeparator,positivePrefix:this.positivePrefix,negativePrefix:this.negativePrefix});if(a===null){return null}else{return a}};DecimalFormat.prototype.checkLocaleChange=function(){if(Locale.getDefault()!=this.formatLocale){this.formatLocale=Locale.getDefault();this.decimalSeparator=this.formatLocale.match(/(bg|cs|de|el|es|fi|fr|hu|in|it|nl|pl|pt|ru|sl|sr|sv|uk|vi)(_\w\w)?/)?",":this.formatLocale.match(/(ar)(_\w\w)?/)?"٫":".";this.groupingSeparator=this.formatLocale.match(/(bg|cs|fi|fr|hu|pl|ru|sv|uk)(_\w\w)?/)?"\u00a0":this.formatLocale.match(/(de|el|es|in|it|nl|pt|sl|sr|vi)(_\w\w)?/)?".":this.formatLocale.match(/(ar)(_\w\w)?/)?"٬":","}};function toLocaleStringUniversal(d,f,e,c,b){if(b.minimumFractionDigits===0){delete b.minimumFractionDigits}var h=d.toLocaleString("en",b);var a=h.indexOf(".");if(a===-1){a=h.length}if(b.maximumFractionDigits===0){if(a<h.length){h=Math.round(d).toString();a=h.length}}else{if(b.maximumFractionDigits<h.length-a-1){h=Math.round(d*Math.pow(10,b.maximumFractionDigits)).toString();if(Math.abs(d)<1){h=d>0?"0."+h:"-0."+h.substring(1)}else{h=h.substring(0,a)+"."+h.substring(a)}}}if(b.minimumFractionDigits>0){if(a===h.length){h+="."}while(b.minimumFractionDigits>h.length-a-1){h+="0"}}if(a>3){if(h.indexOf(",")===-1){if(e){for(var g=a-3;g>(d>0?0:1);g-=3){h=h.substring(0,g)+","+h.substring(g);a++}}}else{if(!e){h=h.replace(/\,/g,"")}}}h=h.replace(".","#");if(e){h=h.replace(/\,/g,f)}h=h.replace("#",c);if(b.negativePrefix&&b.negativePrefix.length>0){h=h.replace("-",b.negativePrefix)}if(d>0&&b.positivePrefix&&b.positivePrefix.length>0){h=b.positivePrefix+h}return h}function parseLocalizedNumber(e,f,i){var c=i.decimalSeparator===undefined;var h=i.decimalSeparator;var g=i.positivePrefix?i.positivePrefix:"";var a=i.negativePrefix?i.negativePrefix:"";e=e.substring(f.getIndex(),e.length);if(g.length>0&&e.indexOf(g)===0){e=e.substring(g.length)}else{if(a.length>0&&e.indexOf(a)===0){e=e.replace(a,"-")}}var d=c?/\d+/g:new RegExp("^\\-?((\\d+\\"+h+"?\\d*)|(\\"+h+"\\d+))","g");if(d.test(e)&&d.lastIndex>0){e=e.substring(0,d.lastIndex);var b=c?parseInt(e):parseFloat(e.replace(h,"."));f.setIndex(f.getIndex()+d.lastIndex);return b}else{return null}}function IntegerFormat(){NumberFormat.call(this)}IntegerFormat.prototype=Object.create(NumberFormat.prototype);IntegerFormat.prototype.constructor=IntegerFormat;IntegerFormat.prototype.format=function(a){if(a==null){return""}return toLocaleStringUniversal(a,"",false,"",{maximumFractionDigits:0})};IntegerFormat.prototype.parse=function(b,a){return parseLocalizedNumber(b,a,{})};function CurrencyFormat(){DecimalFormat.call(this);this.currency="USD";this.setGroupingUsed(true)}CurrencyFormat.prototype=Object.create(DecimalFormat.prototype);CurrencyFormat.prototype.constructor=CurrencyFormat;CurrencyFormat.prototype.format=function(d){try{var f=new Intl.NumberFormat(Locale.getDefault().replace("_","-"),{style:"currency",currency:this.currency});return f.format(d)}catch(a){var c=this.currency.match(/(JPY|VND)/)?0:2;this.setMinimumFractionDigits(c);this.setMaximumFractionDigits(c);var b=DecimalFormat.prototype.format.call(this,d);var e=Locale.getDefault();if(e===null||e.indexOf("en")==0){b=this.currency+b}else{b+=" "+this.currency}return b}};CurrencyFormat.prototype.setCurrency=function(a){this.currency=a};CurrencyFormat.prototype.getCurrency=function(){return this.currency};var Locale={};Locale.getDefault=function(){if(window&&window.defaultLocaleLanguageAndCountry){return window.defaultLocaleLanguageAndCountry}else{if(navigator&&navigator.language&&navigator.language.indexOf("-")>=0){var a=navigator.language.split("-");return a[0]+"_"+a[1].toUpperCase()}else{if(navigator&&navigator.language&&navigator.language.length==2){return navigator.language}else{return null}}}};Locale.setDefault=function(a){if(window){window.defaultLocaleLanguageAndCountry=a}};var UUID={};UUID.randomUUID=function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(d){var b=Math.random()*16|0,a=d=="x"?b:(b&3|8);return a.toString(16)})};Math.toDegrees=function(a){return a*180/Math.PI};Math.toRadians=function(a){return a*Math.PI/180};var KeyStroke={};KeyStroke.getKeyStrokeForEvent=function(b,e){if(KeyStroke.KEY_CODE_TEXTS===undefined){KeyStroke.KEY_CODE_TEXTS=new Array(223);KeyStroke.KEY_CODE_TEXTS[8]="BACK_SPACE";KeyStroke.KEY_CODE_TEXTS[9]="TAB";KeyStroke.KEY_CODE_TEXTS[13]="ENTER";KeyStroke.KEY_CODE_TEXTS[16]="SHIFT";KeyStroke.KEY_CODE_TEXTS[17]="CONTROL";KeyStroke.KEY_CODE_TEXTS[18]="ALT";KeyStroke.KEY_CODE_TEXTS[19]="PAUSE";KeyStroke.KEY_CODE_TEXTS[20]="CAPS_LOCK";KeyStroke.KEY_CODE_TEXTS[27]="ESCAPE";KeyStroke.KEY_CODE_TEXTS[33]="PAGE_UP";KeyStroke.KEY_CODE_TEXTS[34]="PAGE_DOWN";KeyStroke.KEY_CODE_TEXTS[35]="END";KeyStroke.KEY_CODE_TEXTS[36]="HOME";KeyStroke.KEY_CODE_TEXTS[37]="LEFT";KeyStroke.KEY_CODE_TEXTS[38]="UP";KeyStroke.KEY_CODE_TEXTS[39]="RIGHT";KeyStroke.KEY_CODE_TEXTS[40]="DOWN";KeyStroke.KEY_CODE_TEXTS[45]="INSERT";KeyStroke.KEY_CODE_TEXTS[46]="DELETE";KeyStroke.KEY_CODE_TEXTS[48]="0";KeyStroke.KEY_CODE_TEXTS[49]="1";KeyStroke.KEY_CODE_TEXTS[50]="2";KeyStroke.KEY_CODE_TEXTS[51]="3";KeyStroke.KEY_CODE_TEXTS[52]="4";KeyStroke.KEY_CODE_TEXTS[53]="5";KeyStroke.KEY_CODE_TEXTS[54]="6";KeyStroke.KEY_CODE_TEXTS[55]="7";KeyStroke.KEY_CODE_TEXTS[56]="8";KeyStroke.KEY_CODE_TEXTS[57]="9";KeyStroke.KEY_CODE_TEXTS[65]="A";KeyStroke.KEY_CODE_TEXTS[66]="B";KeyStroke.KEY_CODE_TEXTS[67]="C";KeyStroke.KEY_CODE_TEXTS[68]="D";KeyStroke.KEY_CODE_TEXTS[69]="E";KeyStroke.KEY_CODE_TEXTS[70]="F";KeyStroke.KEY_CODE_TEXTS[71]="G";KeyStroke.KEY_CODE_TEXTS[72]="H";KeyStroke.KEY_CODE_TEXTS[73]="I";KeyStroke.KEY_CODE_TEXTS[74]="J";KeyStroke.KEY_CODE_TEXTS[75]="K";KeyStroke.KEY_CODE_TEXTS[76]="L";KeyStroke.KEY_CODE_TEXTS[77]="M";KeyStroke.KEY_CODE_TEXTS[78]="N";KeyStroke.KEY_CODE_TEXTS[79]="O";KeyStroke.KEY_CODE_TEXTS[80]="P";KeyStroke.KEY_CODE_TEXTS[81]="Q";KeyStroke.KEY_CODE_TEXTS[82]="R";KeyStroke.KEY_CODE_TEXTS[83]="S";KeyStroke.KEY_CODE_TEXTS[84]="T";KeyStroke.KEY_CODE_TEXTS[85]="U";KeyStroke.KEY_CODE_TEXTS[86]="V";KeyStroke.KEY_CODE_TEXTS[87]="W";KeyStroke.KEY_CODE_TEXTS[88]="X";KeyStroke.KEY_CODE_TEXTS[89]="Y";KeyStroke.KEY_CODE_TEXTS[90]="Z";KeyStroke.KEY_CODE_TEXTS[91]="META";KeyStroke.KEY_CODE_TEXTS[92]="META";KeyStroke.KEY_CODE_TEXTS[96]="NUMPAD0";KeyStroke.KEY_CODE_TEXTS[97]="NUMPAD1";KeyStroke.KEY_CODE_TEXTS[98]="NUMPAD2";KeyStroke.KEY_CODE_TEXTS[99]="NUMPAD3";KeyStroke.KEY_CODE_TEXTS[100]="NUMPAD4";KeyStroke.KEY_CODE_TEXTS[101]="NUMPAD5";KeyStroke.KEY_CODE_TEXTS[102]="NUMPAD6";KeyStroke.KEY_CODE_TEXTS[103]="NUMPAD7";KeyStroke.KEY_CODE_TEXTS[104]="NUMPAD8";KeyStroke.KEY_CODE_TEXTS[105]="NUMPAD9";KeyStroke.KEY_CODE_TEXTS[106]="MULTIPLY";KeyStroke.KEY_CODE_TEXTS[107]="ADD";KeyStroke.KEY_CODE_TEXTS[109]="VK_SUBTRACT";KeyStroke.KEY_CODE_TEXTS[110]="VK_DECIMAL";KeyStroke.KEY_CODE_TEXTS[111]="VK_DIVIDE";KeyStroke.KEY_CODE_TEXTS[112]="F1";KeyStroke.KEY_CODE_TEXTS[113]="F2";KeyStroke.KEY_CODE_TEXTS[114]="F3";KeyStroke.KEY_CODE_TEXTS[115]="F4";KeyStroke.KEY_CODE_TEXTS[116]="F5";KeyStroke.KEY_CODE_TEXTS[117]="F6";KeyStroke.KEY_CODE_TEXTS[118]="F7";KeyStroke.KEY_CODE_TEXTS[119]="F8";KeyStroke.KEY_CODE_TEXTS[120]="F9";KeyStroke.KEY_CODE_TEXTS[121]="F10";KeyStroke.KEY_CODE_TEXTS[122]="F11";KeyStroke.KEY_CODE_TEXTS[123]="F12";KeyStroke.KEY_CODE_TEXTS[144]="VK_NUM_LOCK";KeyStroke.KEY_CODE_TEXTS[145]="VK_SCROLL_LOCK";KeyStroke.KEY_CODE_TEXTS[186]="VK_SEMICOLON";KeyStroke.KEY_CODE_TEXTS[187]="VK_EQUALS";KeyStroke.KEY_CODE_TEXTS[188]="VK_COMMA";KeyStroke.KEY_CODE_TEXTS[190]="VK_PERIOD";KeyStroke.KEY_CODE_TEXTS[191]="VK_SLASH";KeyStroke.KEY_CODE_TEXTS[219]="VK_OPEN_BRACKET";KeyStroke.KEY_CODE_TEXTS[220]="VK_BACK_SLASH";KeyStroke.KEY_CODE_TEXTS[221]="VK_CLOSE_BRACKET";KeyStroke.KEY_CODE_TEXTS[222]="VK_QUOTE"}var c="";var a=KeyStroke.KEY_CODE_TEXTS[b.keyCode];if(a){if(b.ctrlKey){c+="control "}if(b.altKey){c+="alt "}if(b.metaKey){c+="meta "}if(b.shiftKey){c+="shift "}var d=a.indexOf("VK_")===0?a.substring(3):a;if(e!==undefined){c+=(e=="keyup"?"released ":"pressed ")}c+=d}return c};