/*
 * graphics2d.min.js  version 7.2
 *
 * Sweet Home 3D, Copyright (c) 2020 Emmanuel PUYBARET / eTeks <info@eteks.com>
 *
 * Copyright (c) 1997, 2013, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied OpenJDK 8 source code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
function Graphics2D(b){this.context=b.getContext("2d");this.context.imageSmoothingEnabled=true;this.context.setTransform(1,0,0,1,0,0);this.currentTransform=new java.awt.geom.AffineTransform(1,0,0,1,0,0);var a=window.getComputedStyle(b);this.context.font=a.font;this.color=a.color;this.background=a.background}Graphics2D.prototype.constructor=Graphics2D;Graphics2D.prototype.clear=function(){this.context.clearRect(0,0,this.context.canvas.width,this.context.canvas.height)};Graphics2D.prototype.getContext=function(){return this.context};Graphics2D.prototype.draw=function(a){this.createPathFromShape(a);this.context.stroke()};Graphics2D.prototype.createPathFromShape=function(b){this.context.beginPath();var a=b.getPathIterator(java.awt.geom.AffineTransform.getTranslateInstance(0,0));var c=new Array(6);while(!a.isDone()){switch(a.currentSegment(c)){case java.awt.geom.PathIterator.SEG_MOVETO:this.context.moveTo(c[0],c[1]);break;case java.awt.geom.PathIterator.SEG_LINETO:this.context.lineTo(c[0],c[1]);break;case java.awt.geom.PathIterator.SEG_QUADTO:this.context.lineTo(c[0],c[1]);break;case java.awt.geom.PathIterator.SEG_CUBICTO:this.context.bezierCurveTo(c[0],c[1],c[2],c[3],c[4],c[5]);break;case java.awt.geom.PathIterator.SEG_CLOSE:this.context.closePath();break;default:break}a.next()}};Graphics2D.prototype.fill=function(a){this.createPathFromShape(a);this.context.fill()};Graphics2D.prototype.drawImage=function(c,a,d,b){this.context.drawImage(c,a,d)};Graphics2D.prototype.drawImageWithSize=function(d,b,f,e,a,c){this.context.drawImage(d,b,f,e,a)};Graphics2D.prototype.getClip=function(){return this.clipZone!==undefined?this.clipZone:null};Graphics2D.prototype.setClip=function(a){if(this.clipZone!==undefined){this.context.restore();delete this.clipZone}if(a!=null){this.clip(a)}};Graphics2D.prototype.clip=function(a){if(this.clipZone===undefined){this.context.save()}this.clipZone=a;if(a!=null){this.createPathFromShape(a);this.context.clip()}};Graphics2D.prototype.clipRect=function(b,d,c,a){this.setClip(new java.awt.geom.Rectangle2D.Double(b,d,c,a))};Graphics2D.prototype.translate=function(a,b){this.currentTransform.translate(a,b);this.context.translate(a,b)};Graphics2D.prototype.drawStringOutline=function(b,a,c){this.context.strokeText(b,a,c)};Graphics2D.prototype.drawString=function(b,a,c){this.context.fillText(b,a,c)};Graphics2D.prototype.fillRect=function(b,d,c,a){this.context.fillRect(b,d,c,a)};Graphics2D.prototype.setColor=function(a){this.color=a;this.context.strokeStyle=a;this.context.fillStyle=a};Graphics2D.prototype.getColor=function(){return this.color};Graphics2D.prototype.setComposite=function(a){this.setColor(a)};Graphics2D.prototype.setAlpha=function(a){this.context.globalAlpha=a};Graphics2D.prototype.getAlpha=function(){return this.context.globalAlpha};Graphics2D.prototype.rotate=function(b,a,c){if(typeof a==="number"&&typeof c==="number"){this.currentTransform.rotate(b,a,c);this.context.translate(-a,-c);this.context.rotate(b);this.context.translate(a,c)}else{this.currentTransform.rotate(b);this.context.rotate(b)}};Graphics2D.prototype.scale=function(b,a){this.currentTransform.scale(b,a);this.context.scale(b,a)};Graphics2D.prototype.shear=function(b,a){this.currentTransform.shear(b,a);this.context.transform(0,b,a,0,0,0)};Graphics2D.prototype.dispose=function(){};Graphics2D.prototype.setFont=function(a){this.context.font=a};Graphics2D.prototype.getFont=function(){return this.context.font};Graphics2D.prototype.setBackground=function(a){this.background=a;this.context.fillStyle=a};Graphics2D.prototype.getBackground=function(){return this.background};Graphics2D.prototype.setTransform=function(a){this.currentTransform.setTransform(a);this.context.setTransform(a.getScaleX(),a.getShearY(),a.getShearX(),a.getScaleY(),a.getTranslateX(),a.getTranslateY())};Graphics2D.prototype.getTransform=function(){return new java.awt.geom.AffineTransform(this.currentTransform)};Graphics2D.prototype.transform=function(a){this.currentTransform.concatenate(a);this.context.transform(a.getScaleX(),a.getShearX(),a.getShearY(),a.getScaleY(),a.getTranslateX(),a.getTranslateY())};Graphics2D.prototype.setPaintMode=function(){};Graphics2D.prototype.getPaint=function(){return this.color};Graphics2D.prototype.setPaint=function(a){if(typeof a==="string"){this.setColor(a)}else{this.context.strokeStyle=a;this.context.fillStyle=a}};Graphics2D.prototype.setStroke=function(a){this.context.lineWidth=a.getLineWidth();if(a.getDashArray()!=null){this.context.setLineDash(a.getDashArray());this.context.lineDashOffset=a.getDashPhase()}else{this.context.setLineDash([])}switch(a.getLineJoin()){case java.awt.BasicStroke.JOIN_BEVEL:this.context.lineJoin="bevel";break;case java.awt.BasicStroke.JOIN_MITER:this.context.lineJoin="miter";break;case java.awt.BasicStroke.JOIN_ROUND:this.context.lineJoin="round";break}switch(a.getEndCap()){case java.awt.BasicStroke.CAP_BUTT:this.context.lineCap="butt";break;case java.awt.BasicStroke.CAP_ROUND:this.context.lineCap="round";break;case java.awt.BasicStroke.CAP_SQUARE:this.context.lineCap="square";break}this.context.miterLimit=a.getMiterLimit()};Graphics2D.prototype.createPattern=function(a){return this.context.createPattern(a,"repeat")};function FontMetrics(a){this.approximated=false;this.font=a;this.cached=false}FontMetrics.prototype.constructor=FontMetrics;FontMetrics.prototype.getStringBounds=function(a){this.compute(a);this.cached=false;return new java.awt.geom.Rectangle2D.Double(0,-this.ascent,this.width,this.height)};FontMetrics.prototype.getAscent=function(){if(!this.cached){this.compute("Llp")}return this.ascent};FontMetrics.prototype.getDescent=function(){if(!this.cached){this.compute("Llp")}return this.descent};FontMetrics.prototype.getHeight=function(){if(!this.cached){this.compute("Llp")}return this.height};FontMetrics.prototype.compute=function(a){if(!FontMetrics.context){FontMetrics.context=document.createElement("canvas").getContext("2d")}FontMetrics.context.font=this.font;var c=FontMetrics.context.measureText(a);if(c.fontBoundingBoxAscent){this.cached=true;this.ascent=c.fontBoundingBoxAscent;this.descent=c.fontBoundingBoxDescent;this.height=this.ascent+this.descent;this.width=c.width}else{if(!this.approximated){this.approximated=true;var b=new Font(this.font);this.height=parseInt(b.size);if(["Times","Serif","Helvetica"].indexOf(b.family)===-1){this.height*=1.18}this.descent=0.23*this.height;this.ascent=this.height-this.descent;this.cached=true}this.width=c.width}};function Font(a){if(!Font.element){Font.element=document.createElement("span");Font.element.style.display="none";document.body.appendChild(Font.element)}if(typeof a==="string"){Font.element.style.font=a}else{if(a.style){Font.element.style.fontStyle=a.style}if(a.size){Font.element.style.fontSize=a.size}if(a.family){Font.element.style.fontFamily=a.family}if(a.weight){Font.element.style.fontWeight=a.weight}}this.computedStyle=window.getComputedStyle(Font.element);this.size=this.computedStyle.fontSize;this.family=this.computedStyle.fontFamily;this.style=this.computedStyle.fontStyle;this.weight=this.computedStyle.fontWeight}Font.prototype.constructor=Font;Font.prototype.toString=function(){var a="";if(this.weight!="normal"){a=this.weight+" "}if(this.style!="normal"){a+=this.style+" "}a+=this.size+" "+this.family;return a};function AbstractAction(){this.enabled=true}AbstractAction.DEFAULT="Default";AbstractAction.NAME="Name";AbstractAction.SHORT_DESCRIPTION="ShortDescription";AbstractAction.LONG_DESCRIPTION="LongDescription";AbstractAction.SMALL_ICON="SmallIcon";AbstractAction.ACTION_COMMAND_KEY="ActionCommandKey";AbstractAction.ACCELERATOR_KEY="AcceleratorKey";AbstractAction.MNEMONIC_KEY="MnemonicKey";AbstractAction.SELECTED_KEY="SwingSelectedKey";AbstractAction.DISPLAYED_MNEMONIC_INDEX_KEY="SwingDisplayedMnemonicIndexKey";AbstractAction.LARGE_ICON_KEY="SwingLargeIconKey";AbstractAction.prototype.actionPerformed=function(a){throw new UnsupportedOperationException()};AbstractAction.prototype.getValue=function(a){if(a=="enabled"){return this.enabled}if(this.arrayTable==null){return null}return this.arrayTable[a]};AbstractAction.prototype.putValue=function(b,c){var a=null;if(b=="enabled"){if(c==null||!(c instanceof Boolean)){c=false}a=enabled;this.enabled=c}else{if(this.arrayTable==null){this.arrayTable={}}if(this.arrayTable[b]!=null){a=this.arrayTable[b]}if(c==null){delete this.arrayTable.key}else{this.arrayTable[b]=c}}if(this.changeSupport!=null){this.firePropertyChange(b,a,c)}};AbstractAction.prototype.isEnabled=function(){return this.enabled};AbstractAction.prototype.setEnabled=function(a){if(this.enabled!=a){this.enabled=a;if(this.changeSupport!=null){this.firePropertyChange("enabled",!a,a)}}};AbstractAction.prototype.getKeys=function(){if(this.arrayTable==null){return null}return this.arrayTable.getOwnPropertyNames()};AbstractAction.prototype.firePropertyChange=function(a,b,c){if(this.changeSupport==null||(b!=null&&c!=null&&b==c)){return}this.changeSupport.firePropertyChange(a,b,c)};AbstractAction.prototype.addPropertyChangeListener=function(a){if(this.changeSupport==null){this.changeSupport=new PropertyChangeSupport(this)}this.changeSupport.addPropertyChangeListener(a)};AbstractAction.prototype.removePropertyChangeListener=function(a){if(this.changeSupport==null){return}this.changeSupport.removePropertyChangeListener(a)};AbstractAction.prototype.getPropertyChangeListeners=function(){if(this.changeSupport==null){return new PropertyChangeListener[0]}return this.changeSupport.getPropertyChangeListeners()};